﻿-- false = 0
-- true = 1
local pheeFrame = CreateFrame("FRAME", "PheeLoggerFrame");
-- register events
pheeFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
pheeFrame:RegisterEvent("PARTY_MEMBERS_CHANGED");
pheeFrame:RegisterEvent("PARTY_CONVERTED_TO_RAID");
pheeFrame:RegisterEvent("ADDON_LOADED");
-- some function
local function checkStatus(self, event)
	-- get current condition
    pheeInInstance, pheeInstanceType = IsInInstance();
	pheeMembers = GetNumRaidMembers();
	-- check for conditions
	-- raid instance
    if pheeInInstance == 1 then
        if pheeInstanceType == "raid" then
			if pheeLoggerStartInstance == "yes" then
				if (LoggingCombat()) then
					if pheeLoggerIsLogging == 1 then
						print("|cff00E9FAPL:|r Welcome back. We're still logging combat.");
					end
				else
					if pheeLoggerIsLogging == 0 then
						print("|cff00E9FAPL:|r Welcome. We start logging combat!");
					end
					pheeLoggerIsLogging = 1;
				end
			end
        else
			if pheeLoggerEndInstance == "yes" then
				if pheeLoggerIsLogging == 1 then
					print("|cff00E9FAPL:|r No raid! Stop logging combat!");
				end
				pheeLoggerIsLogging = 0;
			end
        end
    else
		if pheeLoggerEndInstance == "yes" then
			if pheeLoggerIsLogging == 1 then
				print("|cff00E9FAPL:|r We're outside. Stop logging combat!");
			end
			pheeLoggerIsLogging = 0;
		end
    end
	-- raid group
	if pheeMembers == 0 then
		if pheeLoggerEndGroup == "yes" then
			if pheeLoggerIsLogging == 1 then
				print("|cff00E9FAPL:|r No raid group. Stop logging combat!");
			end
			pheeLoggerIsLogging = 0;
		end
	else
		if pheeLoggerStartGroup == "yes" then
			if (LoggingCombat()) then
				if pheeLoggerIsLogging == 1 then
					print("|cff00E9FAPL:|r Still in raid. We're still logging combat!");
				end
			else
				if pheeLoggerIsLogging == 1 then
					print("|cff00E9FAPL:|r Raid group found. We start logging combat!");
				end
				pheeLoggerIsLogging = 1;
			end
		end
	end
	startStopPheeLog();
end
-- start/stop loggin
local function startStopPheeLog()
	if pheeLoggerIsLogging == 1 then
		if (LoggingCombat()) then
				LoggingCombat(1);
		else
			LoggingCombat(1);
		end
	else
		if (LoggingCombat()) then
				LoggingCombat(0);
		else
			LoggingCombat(0);
		end
	end
end
-- setup
local function setupPheeLogger(self, event)
	-- set default values
    if pheeLoggerFrame == nil then
        pheeLoggerFrame = "show";
    end
    if pheeLoggerStartGroup == nil then
        pheeLoggerStartGroup = "no";
    end
	pheeLoggerIsLogging = 0;
    if pheeLoggerStartInstance == nil then
        pheeLoggerStartInstance = "yes";
    end
    if pheeLoggerEndGroup == nil then
        pheeLoggerEndGroup = "yes";
    end
    if pheeLoggerEndInstance == nil then
        pheeLoggerEndInstance = "no";
    end
	-- do the view
    if pheeLoggerFrame == "yes" then
        PheeLoggerForm:Show();
    end
    if pheeLoggerFrame == "no" then
        PheeLoggerForm:Hide();
    end
    if pheeLoggerStartGroup == "yes" then
        CheckStartGroup:SetChecked(1);
	else
        CheckStartGroup:SetChecked(0);
	end
    if pheeLoggerStartInstance == "yes" then
        CheckStartInstance:SetChecked(1);
	else
        CheckStartInstance:SetChecked(0);
	end
    if pheeLoggerEndGroup == "yes" then
        CheckEndGroup:SetChecked(1);
	else
        CheckEndGroup:SetChecked(0);
	end
    if pheeLoggerEndInstance == "yes" then
        CheckEndInstance:SetChecked(1);
	else
        CheckEndInstance:SetChecked(0);
	end
	-- print info
	print("|cff00E9FAPL:|r Phee Logger |cff00FF00loaded|r.");
	print("|cff00E9FAPL:|r Use /pl for options");
end
-- update values
function updatePheeLoggerVariables()
	if CheckStartGroup:GetChecked() == 1 then
		pheeLoggerStartGroup = "yes";
	else
		pheeLoggerStartGroup = "no";
	end
	if CheckStartInstance:GetChecked() == 1 then
		pheeLoggerStartInstance = "yes";
	else
		pheeLoggerStartInstance = "no";
	end
	if CheckEndGroup:GetChecked() == 1 then
		pheeLoggerEndGroup = "yes";
	else
		pheeLoggerEndGroup = "no";
	end
	if CheckEndInstance:GetChecked() == 1 then
		pheeLoggerEndInstance = "yes";
	else
		pheeLoggerEndInstance = "no";
	end
	if PheeLoggerForm:IsVisible() == 1 then
		pheeLoggerFrame = "yes";
	else
		pheeLoggerFrame = "no";
	end
end
-- handle events
local function eventHandler(self, event, arg)
    if event == "ADDON_LOADED" then
		if arg == "PheeLogger" then
			setupPheeLogger(self, event);
		end
	end
    if event == "PLAYER_ENTERING_WORLD" then
        checkStatus(self, event);
    end
    if event == "PARTY_MEMBERS_CHANGED" then
		checkStatus(self, event);
    end
    if event == "PARTY_CONVERTED_TO_RAID" then
    end
end
-- register event handler
pheeFrame:SetScript("OnEvent", eventHandler);
-- make slash command
SLASH_PHEELOGGER1 = '/pl';
local function slashHandler(msg, editbox)
	if PheeLoggerForm:IsVisible() == 1 then
		pheeLoggerFrame = "no";
		PheeLoggerForm:Hide();
    else
		pheeLoggerFrame = "yes";
		PheeLoggerForm:Show();
	end
end
SlashCmdList["PHEELOGGER"] = slashHandler; -- Also a valid assignment strategy